com.smartgwt.client.widgets.form

## Class FilterBuilder

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.form.FilterBuilder

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClearHandlers, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasRuleContextChangedHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasFilterChangedHandlers, HasSearchHandlers, HasMembersChangedHandlers

      public class FilterBuilder
      extends Layout
      implements HasFilterChangedHandlers, HasSearchHandlers

  A form that allows the user to input advanced search criteria, including operators on field values such as "less than", and sub-clauses using "AND" and "OR" operators.

  A FilterBuilder produces an `AdvancedCriteria` object, which the `DataSource` subsystem can use to filter datasets, including the ability to perform such filtering within the browser for datasets that are completely loaded.

  The operators available for each field can be customized at the DataSource level via `DataSourceField.validOperators`, `DataSource.setTypeOperators()` and related APIs.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilterBuilder()`
    `FilterBuilder(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addClause(FilterClause filterClause)` Add a new `FilterClause` to this FilterBuilder.
    `void` | `addCriterion(Criterion criterion)` Add a new criterion, including recursively adding sub-criteria for a criterion that contains other criteria.
    `com.google.gwt.event.shared.HandlerRegistration` | `addFilterChangedHandler(FilterChangedHandler handler)` Add a filterChanged handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addSearchHandler(SearchHandler handler)` Add a search handler.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `void` | `clearCriteria()` Clear all current criteria.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `ImgButton` | `getAddButton()` An ImgButton that allows new clauses to be added if `showAddButton` is set.
    `java.lang.String` | `getAddButtonPrompt()` The hover prompt text for the add button.
    `java.lang.String[]` | `getAllowedFields()` List of explicit fields for user field selection.
    `java.lang.Boolean` | `getAllowEmpty()` If set to false, the last clause cannot be removed.
    `Canvas` | `getBracket()` Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists.
    `VStack` | `getClauseStack()` VStack of all clauses that are part of this FilterBuilder
    `AdvancedCriteria` | `getCriteria()` Initial criteria.
    `AdvancedCriteria` | `getCriteria(boolean includeEmptyValues)` Initial criteria.
    `DataSource` | `getDataSource()` DataSource this filter should use for field definitions and available `Operator`s.
    `java.lang.String` | `getDataSourceAsString()` DataSource this filter should use for field definitions and available `Operator`s.
    `java.lang.String` | `getEditorType(DataSourceField field, OperatorId operatorId)` Returns the type of editor to use for the field.
    `DataSource` | `getFieldDataSource()` If specified, the FilterBuilder will dynamically fetch DataSourceField definitions from this DataSource rather than using `dataSource`.
    `FormItem` | `getFieldPickerProperties()` Properties to combine with the `FieldPicker` autoChild FormItem.
    `java.lang.String` | `getFieldPickerTitle()` The title for the `field-picker` select-item.
    `java.lang.Integer` | `getFieldPickerWidth()` Width for the field picker formItem displayed in clauses within this FilterBuilder.
    `java.lang.String` | `getFieldPickerWidthAsString()` Width for the field picker formItem displayed in clauses within this FilterBuilder.
    `java.lang.String` | `getInlineAndNotTitle()` Title for the "And Not" operator (only applicable to the "inline" appearance)
    `java.lang.String` | `getInlineAndTitle()` Title for the "And" operator (only applicable to the "inline" appearance)
    `java.lang.String` | `getInlineOrTitle()` Title for the "Or" operator (only applicable to the "inline" appearance)
    `java.lang.String` | `getLastClausePrompt()` The hover prompt text for the remove button in the last remaining clause, when `allowEmpty` is false.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `java.lang.String` | `getMatchAllTitle()` Title for the "Match All" (and) operator when using `topOperatorAppearance`:"radio".
    `java.lang.String` | `getMatchAnyTitle()` Title for the "Match Any" (or) operator when using `topOperatorAppearance`:"radio".
    `java.lang.String` | `getMatchNoneTitle()` Title for the "Match None" (not) operator when using `topOperatorAppearance`:"radio".
    `Canvas[]` | `getMembers()` An array of canvases that will be contained within this layout.
    `java.lang.String` | `getMissingFieldPrompt()` The message to display next to fieldNames that do not exist in the available dataSource.
    `Label` | `getModeSwitcher()` Label to change between simple and advanced mode.
    `java.lang.String` | `getModeSwitcherAdvancedMessage()` Title for the "Advanced.." mode switcher label (only applicable to the "radio" appearance).
    `java.lang.String` | `getModeSwitcherFlattenWarningMessage()` Message displayed when switching to "radio" mode if the criteria will be logically changed.
    `java.lang.String` | `getModeSwitcherSimpleMessage()` Title for the "Simple Mode.." mode switcher label (only applicable to the "bracket" appearance).
    `SelectItem` | `getOperatorPicker()` Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists.
    `FormItem` | `getOperatorPickerProperties()` Properties to combine with the `operatorPicker` autoChild FormItem.
    `java.lang.String` | `getOperatorPickerTitle()` The title for the operator-picker select-item.
    `java.lang.Integer` | `getOperatorPickerWidth()` Width for the operator picker formItem displayed in clauses within this FilterBuilder.
    `java.lang.String` | `getOperatorPickerWidthAsString()` Width for the operator picker formItem displayed in clauses within this FilterBuilder.
    `static FilterBuilder` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `DynamicForm` | `getRadioOperatorForm()` With `TopOperatorAppearance`:"radio", form that appears above the stack of clauses and allows picking the `LogicalOperator` for the overall FilterBuilder.
    `HLayout` | `getRadioOperatorLayout()` HLayout of radioOperationForm and optional modeSwitcher.
    `java.lang.String` | `getRadioOperatorTitle()` The title for the Operator RadioGroupItem displayed in the `radioOperatorForm`.
    `java.lang.String` | `getRangeSeparator()` For operators that check that a value is within a range, text to show between the start and end input fields for specifying the limits of the range.
    `ImgButton` | `getRemoveButton()` The removal ImgButton that appears before each clause if `showRemoveButton` is set.
    `java.lang.String` | `getRemoveButtonPrompt()` The hover prompt text for the remove button.
    `java.lang.Boolean` | `getRetainValuesAcrossFields()` Dictates whether values entered by a user should be retained in the value fields when a different field is selected.
    `java.lang.Boolean` | `getSaveOnEnter()` If true, when the user hits the Enter key while focused in a text-item in this FilterBuilder, we automatically invoke the user-supplied `FilterBuilder.search()` method.
    `FilterClause[]` | `getSelectedClauses()` Returns the list of this FilterBuilder's FilterClauses that are currently selected.
    `java.lang.Boolean` | `getShowAddButton()` If set, a button will be shown underneath all current clauses allowing a new clause to be added.
    `java.lang.Boolean` | `getShowFieldTitles()` If true (the default), show field titles in the drop-down box used to select a field for querying.
    `java.lang.Boolean` | `getShowHiddenFields()` By default only non-hidden fields are shown for selection.
    `java.lang.Boolean` | `getShowLastRemoveButton()` If set to false and showing clause `remove buttons` and `the last clause cannot be removed` the remove clause button will be hidden.
    `java.lang.Boolean` | `getShowModeSwitcher()` When enabled allows FilterBuilder in `topOperatorAppearance:"radio"` or `topOperatorAppearance:"bracket"` mode to be switch to the other view by the user.
    `java.lang.Boolean` | `getShowRemoveButton()` If set, a button will be shown for each clause allowing it to be removed.
    `java.lang.Boolean` | `getShowSelectionCheckbox()` If true, causes a CheckboxItem to appear to the left of each clause in "inline" `appearance`.
    `java.lang.Boolean` | `getShowSubClauseButton()` Whether to show a button that allows the user to add subclauses.
    `java.lang.Boolean` | `getSortFields()` Should the `FieldPicker` items be sorted alphabetically in the drop down list.
    `IButton` | `getSubClauseButton()` Button allowing the user to add subclauses grouped by a `LogicalOperator`.
    `java.lang.String` | `getSubClauseButtonPrompt()` The hover prompt text for the subClauseButton.
    `java.lang.String` | `getSubClauseButtonTitle()` The title of the subClauseButton
    `LogicalOperator` | `getTopOperator()` Default logical operator for all top-level clauses in the FilterBuilder.
    `TopOperatorAppearance` | `getTopOperatorAppearance()` How to display and edit the `top-level operator` for this FilterBuilder.
    `DynamicForm` | `getTopOperatorForm()` With `TopOperatorAppearance` "bracket" and "inline", a form that appears to the left of the stack of clauses and allows picking the `LogicalOperator` for the overall FilterBuilder (or for that specific FilterClause, in the case of "inline")
    `SelectItem` | `getTopOperatorItem()` Automatically generated SelectItem autoChild shown in the `topOperatorForm`.
    `int` | `getTopOperatorItemWidth()` Width for the `topOperatorItem` autoChild.
    `java.lang.String` | `getTopOperatorItemWidthAsString()` Width for the `topOperatorItem` autoChild.
    `OperatorId[]` | `getTopOperatorOptions()` Logical operators to allow for `TopOperatorAppearance`s of "radio" and "bracket".
    `java.lang.String` | `getTopOperatorTitle()` The title for the left-aligned Operator selectItem in the `topOperatorForm`.
    `java.lang.Boolean` | `getValidateOnChange()` If true (the default), validates each entered value when it changes, to make sure it is a a valid value of its type (valid string, number, and so on).
    `FormItem` | `getValueFieldProperties(FieldType type, java.lang.String fieldName, OperatorId operatorId, ValueItemType itemType, java.lang.String fieldType)` Override to return properties for the FormItem(s) used for the "value" field displayed within clauses within this filterBuilder.
    `java.lang.Integer` | `getValueItemWidth()` Width for the value-chooser formItem displayed in clauses within this FilterBuilder.
    `java.lang.String` | `getValueItemWidthAsString()` Width for the value-chooser formItem displayed in clauses within this FilterBuilder.
    `protected void` | `onInit_FilterBuilder()`
    `void` | `onInit()`
    `void` | `removeClause(FilterClause clause)` Remove a clause this FilterBuilder is currently showing.
    `FilterBuilder` | `setAddButtonPrompt(java.lang.String addButtonPrompt)` The hover prompt text for the add button.
    `FilterBuilder` | `setAllowedFields(java.lang.String... allowedFields)` List of explicit fields for user field selection.
    `FilterBuilder` | `setAllowEmpty(java.lang.Boolean allowEmpty)` If set to false, the last clause cannot be removed.
    `FilterBuilder` | `setCriteria(AdvancedCriteria criteria)` Initial criteria.
    `void` | `setDataSource(DataSource dataSource)` DataSource this filter should use for field definitions and available `Operator`s.
    `static void` | `setDefaultProperties(FilterBuilder filterBuilderProperties)` Class level method to set the default properties of this class.
    `FilterBuilder` | `setFieldDataSource(DataSource fieldDataSource)` If specified, the FilterBuilder will dynamically fetch DataSourceField definitions from this DataSource rather than using `dataSource`.
    `void` | `setFieldOperatorCustomizer(FieldOperatorCustomizer customizer)` This method installs a customizer that returns the set of OperatorIds applicable to the passed fieldName
    `FilterBuilder` | `setFieldPickerProperties(FormItem fieldPickerProperties)` Properties to combine with the `FieldPicker` autoChild FormItem.
    `FilterBuilder` | `setFieldPickerTitle(java.lang.String fieldPickerTitle)` The title for the `field-picker` select-item.
    `FilterBuilder` | `setFieldPickerWidth(java.lang.Integer fieldPickerWidth)` Width for the field picker formItem displayed in clauses within this FilterBuilder.
    `FilterBuilder` | `setFieldPickerWidth(java.lang.String fieldPickerWidth)` Width for the field picker formItem displayed in clauses within this FilterBuilder.
    `FilterBuilder` | `setInlineAndNotTitle(java.lang.String inlineAndNotTitle)` Title for the "And Not" operator (only applicable to the "inline" appearance)
    `FilterBuilder` | `setInlineAndTitle(java.lang.String inlineAndTitle)` Title for the "And" operator (only applicable to the "inline" appearance)
    `FilterBuilder` | `setInlineOrTitle(java.lang.String inlineOrTitle)` Title for the "Or" operator (only applicable to the "inline" appearance)
    `FilterBuilder` | `setLastClausePrompt(java.lang.String lastClausePrompt)` The hover prompt text for the remove button in the last remaining clause, when `allowEmpty` is false.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.form.FilterBuilderLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `FilterBuilder` | `setMatchAllTitle(java.lang.String matchAllTitle)` Title for the "Match All" (and) operator when using `topOperatorAppearance`:"radio".
    `FilterBuilder` | `setMatchAnyTitle(java.lang.String matchAnyTitle)` Title for the "Match Any" (or) operator when using `topOperatorAppearance`:"radio".
    `FilterBuilder` | `setMatchNoneTitle(java.lang.String matchNoneTitle)` Title for the "Match None" (not) operator when using `topOperatorAppearance`:"radio".
    `FilterBuilder` | `setMissingFieldPrompt(java.lang.String missingFieldPrompt)` The message to display next to fieldNames that do not exist in the available dataSource.
    `FilterBuilder` | `setModeSwitcherAdvancedMessage(java.lang.String modeSwitcherAdvancedMessage)` Title for the "Advanced.." mode switcher label (only applicable to the "radio" appearance).
    `FilterBuilder` | `setModeSwitcherFlattenWarningMessage(java.lang.String modeSwitcherFlattenWarningMessage)` Message displayed when switching to "radio" mode if the criteria will be logically changed.
    `FilterBuilder` | `setModeSwitcherSimpleMessage(java.lang.String modeSwitcherSimpleMessage)` Title for the "Simple Mode.." mode switcher label (only applicable to the "bracket" appearance).
    `FilterBuilder` | `setOperatorPickerProperties(FormItem operatorPickerProperties)` Properties to combine with the `operatorPicker` autoChild FormItem.
    `FilterBuilder` | `setOperatorPickerTitle(java.lang.String operatorPickerTitle)` The title for the operator-picker select-item.
    `FilterBuilder` | `setOperatorPickerWidth(java.lang.Integer operatorPickerWidth)` Width for the operator picker formItem displayed in clauses within this FilterBuilder.
    `FilterBuilder` | `setOperatorPickerWidth(java.lang.String operatorPickerWidth)` Width for the operator picker formItem displayed in clauses within this FilterBuilder.
    `FilterBuilder` | `setRadioOperatorTitle(java.lang.String radioOperatorTitle)` The title for the Operator RadioGroupItem displayed in the `radioOperatorForm`.
    `FilterBuilder` | `setRangeSeparator(java.lang.String rangeSeparator)` For operators that check that a value is within a range, text to show between the start and end input fields for specifying the limits of the range.
    `FilterBuilder` | `setRemoveButtonPrompt(java.lang.String removeButtonPrompt)` The hover prompt text for the remove button.
    `FilterBuilder` | `setRetainValuesAcrossFields(java.lang.Boolean retainValuesAcrossFields)` Dictates whether values entered by a user should be retained in the value fields when a different field is selected.
    `FilterBuilder` | `setSaveOnEnter(java.lang.Boolean saveOnEnter)` If true, when the user hits the Enter key while focused in a text-item in this FilterBuilder, we automatically invoke the user-supplied `FilterBuilder.search()` method.
    `FilterBuilder` | `setShowAddButton(java.lang.Boolean showAddButton)` If set, a button will be shown underneath all current clauses allowing a new clause to be added.
    `void` | `setShowFieldTitles(boolean showFieldTitles)` If true (the default), show field titles in the drop-down box used to select a field for querying.
    `FilterBuilder` | `setShowFieldTitles(java.lang.Boolean showFieldTitles)` If true (the default), show field titles in the drop-down box used to select a field for querying.
    `FilterBuilder` | `setShowHiddenFields(java.lang.Boolean showHiddenFields)` By default only non-hidden fields are shown for selection.
    `FilterBuilder` | `setShowLastRemoveButton(java.lang.Boolean showLastRemoveButton)` If set to false and showing clause `remove buttons` and `the last clause cannot be removed` the remove clause button will be hidden.
    `FilterBuilder` | `setShowModeSwitcher(java.lang.Boolean showModeSwitcher)` When enabled allows FilterBuilder in `topOperatorAppearance:"radio"` or `topOperatorAppearance:"bracket"` mode to be switch to the other view by the user.
    `FilterBuilder` | `setShowRemoveButton(java.lang.Boolean showRemoveButton)` If set, a button will be shown for each clause allowing it to be removed.
    `FilterBuilder` | `setShowSelectionCheckbox(java.lang.Boolean showSelectionCheckbox)` If true, causes a CheckboxItem to appear to the left of each clause in "inline" `appearance`.
    `FilterBuilder` | `setShowSubClauseButton(java.lang.Boolean showSubClauseButton)` Whether to show a button that allows the user to add subclauses.
    `FilterBuilder` | `setSortFields(java.lang.Boolean sortFields)` Should the `FieldPicker` items be sorted alphabetically in the drop down list.
    `FilterBuilder` | `setSubClauseButtonPrompt(java.lang.String subClauseButtonPrompt)` The hover prompt text for the subClauseButton.
    `FilterBuilder` | `setSubClauseButtonTitle(java.lang.String subClauseButtonTitle)` The title of the subClauseButton
    `FilterBuilder` | `setTopOperator(LogicalOperator topOperator)` Default logical operator for all top-level clauses in the FilterBuilder.
    `FilterBuilder` | `setTopOperatorAppearance(TopOperatorAppearance topOperatorAppearance)` How to display and edit the `top-level operator` for this FilterBuilder.
    `FilterBuilder` | `setTopOperatorItemWidth(int topOperatorItemWidth)` Width for the `topOperatorItem` autoChild.
    `FilterBuilder` | `setTopOperatorItemWidth(java.lang.String topOperatorItemWidth)` Width for the `topOperatorItem` autoChild.
    `FilterBuilder` | `setTopOperatorOptions(OperatorId... topOperatorOptions)` Logical operators to allow for `TopOperatorAppearance`s of "radio" and "bracket".
    `FilterBuilder` | `setTopOperatorTitle(java.lang.String topOperatorTitle)` The title for the left-aligned Operator selectItem in the `topOperatorForm`.
    `FilterBuilder` | `setValidateOnChange(java.lang.Boolean validateOnChange)` If true (the default), validates each entered value when it changes, to make sure it is a a valid value of its type (valid string, number, and so on).
    `FilterBuilder` | `setValueItemWidth(java.lang.Integer valueItemWidth)` Width for the value-chooser formItem displayed in clauses within this FilterBuilder.
    `FilterBuilder` | `setValueItemWidth(java.lang.String valueItemWidth)` Width for the value-chooser formItem displayed in clauses within this FilterBuilder.
    `java.lang.Boolean` | `validate()` Validate the clauses of this FilterBuilder.

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, dataContextChanged, deparent, depeer, disable, enable, encloses, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAriaStateDefaults, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCorrectZoomOverflow, getCursor, getDataContext, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getTabIndex, getTestDataContext, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUISummary, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDragMask, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setTabIndex, setTestDataContext, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDragMask, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### FilterBuilder

          public FilterBuilder()

    - #### FilterBuilder

          public FilterBuilder(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static FilterBuilder getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `Layout`

    - #### getAddButton

          public ImgButton getAddButton()
                                 throws java.lang.IllegalStateException

      An ImgButton that allows new clauses to be added if `showAddButton` is set.

      This component is an AutoChild named "addButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current addButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setAddButtonPrompt

          public FilterBuilder setAddButtonPrompt(java.lang.String addButtonPrompt)
                                           throws java.lang.IllegalStateException

      The hover prompt text for the add button.
      Parameters:
        `addButtonPrompt` - New addButtonPrompt value. Default value is "Add"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getAddButtonPrompt

          public java.lang.String getAddButtonPrompt()

      The hover prompt text for the add button.
      Returns:
        Current addButtonPrompt value. Default value is "Add"

    - #### setAllowedFields

          public FilterBuilder setAllowedFields(java.lang.String... allowedFields)
                                         throws java.lang.IllegalStateException

      List of explicit fields for user field selection. If not specified, the list of fields is derived from the `dataSource`.

      Note: this property is not a security feature as it only controls the UI. To consistently limit searchability for certain fields use `canFilter`.

      Parameters:
        `allowedFields` - New allowedFields value. Default value is null
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setShowHiddenFields(java.lang.Boolean)`

    - #### getAllowedFields

          public java.lang.String[] getAllowedFields()

      List of explicit fields for user field selection. If not specified, the list of fields is derived from the `dataSource`.

      Note: this property is not a security feature as it only controls the UI. To consistently limit searchability for certain fields use `canFilter`.

      Returns:
        Current allowedFields value. Default value is null
      See Also:
        `getShowHiddenFields()`

    - #### setAllowEmpty

          public FilterBuilder setAllowEmpty(java.lang.Boolean allowEmpty)
                                      throws java.lang.IllegalStateException

      If set to false, the last clause cannot be removed.
      Parameters:
        `allowEmpty` - New allowEmpty value. Default value is false
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getAllowEmpty

          public java.lang.Boolean getAllowEmpty()

      If set to false, the last clause cannot be removed.
      Returns:
        Current allowEmpty value. Default value is false

    - #### getBracket

          public Canvas getBracket()

      Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists. See `Using AutoChildren` for details.

      Widget used as a "bracket" to hint to the user that a subclause groups several field-by-field filter criteria under one logical operator.

      By default, a simple CSS-style Canvas with borders on three sides. A vertical StretchImg could provide a more elaborate appearance.

      Returns:
        null

    - #### getClauseStack

          public VStack getClauseStack()
                                throws java.lang.IllegalStateException

      VStack of all clauses that are part of this FilterBuilder

      This component is an AutoChild named "clauseStack". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current clauseStack value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setCriteria

          public FilterBuilder setCriteria(AdvancedCriteria criteria)

      Initial criteria.

      When initialized with criteria, appropriate clauses for editing the provided criteria will be automatically generated.

      Note that empty or partial criteria are allowed, for example, criteria that specify `Criterion.fieldName` only will generate an expression with the operator not chosen yet, and a `Criterion` with a logical operator ("and" or "or") but not `subcriteria` defined will generate an empty subclause.
      If this method is called after the component has been drawn/initialized: Set new criteria for editing.

      An interface for editing the provided criteria will be generated identically to what happens when initialized with `Criteria`.

      Any existing criteria entered by the user will be discarded.

      Parameters:
        `criteria` - new criteria. Pass null or {} to effectively reset the filterBuilder to it's initial state when no criteria are specified. Default value is null
      Returns:
        `FilterBuilder` instance, for chaining setter calls

    - #### getCriteria

          public AdvancedCriteria getCriteria()

      Initial criteria.

      When initialized with criteria, appropriate clauses for editing the provided criteria will be automatically generated.

      Note that empty or partial criteria are allowed, for example, criteria that specify `Criterion.fieldName` only will generate an expression with the operator not chosen yet, and a `Criterion` with a logical operator ("and" or "or") but not `subcriteria` defined will generate an empty subclause.

      Returns:
        Get the criteria entered by the user. Default value is null

    - #### getDataSource

          public DataSource getDataSource()

      DataSource this filter should use for field definitions and available `Operator`s.
      Returns:
        Current dataSource value. Default value is null

    - #### getDataSourceAsString

          public java.lang.String getDataSourceAsString()

      DataSource this filter should use for field definitions and available `Operator`s.
      Returns:
        Current dataSource value. Default value is null

    - #### setFieldDataSource

          public FilterBuilder setFieldDataSource(DataSource fieldDataSource)
                                           throws java.lang.IllegalStateException

      If specified, the FilterBuilder will dynamically fetch DataSourceField definitions from this DataSource rather than using `dataSource`. The `FieldPicker` will default to being a `ComboBoxItem` rather than a `SelectItem` so that the user will have type-ahead auto-completion.

      The records returned from the `fieldDataSource` must have properties corresponding to a `DataSourceField` definition, at a minimum, `"name"` and `"type"`. Any property legal on a DataSourceField is legal on the returned records, including `valueMap`.

      Even when a `fieldDataSource` is specified, `dataSource` may still be specified in order to control the list of `valid operators` for each field.

      Parameters:
        `fieldDataSource` - New fieldDataSource value. Default value is null
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFieldDataSource

          public DataSource getFieldDataSource()

      If specified, the FilterBuilder will dynamically fetch DataSourceField definitions from this DataSource rather than using `dataSource`. The `FieldPicker` will default to being a `ComboBoxItem` rather than a `SelectItem` so that the user will have type-ahead auto-completion.

      The records returned from the `fieldDataSource` must have properties corresponding to a `DataSourceField` definition, at a minimum, `"name"` and `"type"`. Any property legal on a DataSourceField is legal on the returned records, including `valueMap`.

      Even when a `fieldDataSource` is specified, `dataSource` may still be specified in order to control the list of `valid operators` for each field.

      Returns:
        Current fieldDataSource value. Default value is null

    - #### setFieldPickerProperties

          public FilterBuilder setFieldPickerProperties(FormItem fieldPickerProperties)
                                                 throws java.lang.IllegalStateException

      Properties to combine with the `FieldPicker` autoChild FormItem.
      Parameters:
        `fieldPickerProperties` - New fieldPickerProperties value. Default value is null
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFieldPickerProperties

          public FormItem getFieldPickerProperties()

      Properties to combine with the `FieldPicker` autoChild FormItem.
      Returns:
        Current fieldPickerProperties value. Default value is null

    - #### setFieldPickerTitle

          public FilterBuilder setFieldPickerTitle(java.lang.String fieldPickerTitle)
                                            throws java.lang.IllegalStateException

      The title for the `field-picker` select-item.
      Parameters:
        `fieldPickerTitle` - New fieldPickerTitle value. Default value is "Field Name"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFieldPickerTitle

          public java.lang.String getFieldPickerTitle()

      The title for the `field-picker` select-item.
      Returns:
        Current fieldPickerTitle value. Default value is "Field Name"

    - #### setFieldPickerWidth

          public FilterBuilder setFieldPickerWidth(java.lang.Integer fieldPickerWidth)
                                            throws java.lang.IllegalStateException

      Width for the field picker formItem displayed in clauses within this FilterBuilder.
      Parameters:
        `fieldPickerWidth` - New fieldPickerWidth value. Default value is "*"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFieldPickerWidth

          public java.lang.Integer getFieldPickerWidth()

      Width for the field picker formItem displayed in clauses within this FilterBuilder.
      Returns:
        Current fieldPickerWidth value. Default value is "*"

    - #### setFieldPickerWidth

          public FilterBuilder setFieldPickerWidth(java.lang.String fieldPickerWidth)
                                            throws java.lang.IllegalStateException

      Width for the field picker formItem displayed in clauses within this FilterBuilder.
      Parameters:
        `fieldPickerWidth` - New fieldPickerWidth value. Default value is "*"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFieldPickerWidthAsString

          public java.lang.String getFieldPickerWidthAsString()

      Width for the field picker formItem displayed in clauses within this FilterBuilder.
      Returns:
        Current fieldPickerWidth value. Default value is "*"

    - #### setInlineAndNotTitle

          public FilterBuilder setInlineAndNotTitle(java.lang.String inlineAndNotTitle)
                                             throws java.lang.IllegalStateException

      Title for the "And Not" operator (only applicable to the "inline" appearance)
      Parameters:
        `inlineAndNotTitle` - New inlineAndNotTitle value. Default value is "and not"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getInlineAndNotTitle

          public java.lang.String getInlineAndNotTitle()

      Title for the "And Not" operator (only applicable to the "inline" appearance)
      Returns:
        Current inlineAndNotTitle value. Default value is "and not"

    - #### setInlineAndTitle

          public FilterBuilder setInlineAndTitle(java.lang.String inlineAndTitle)
                                          throws java.lang.IllegalStateException

      Title for the "And" operator (only applicable to the "inline" appearance)
      Parameters:
        `inlineAndTitle` - New inlineAndTitle value. Default value is "and"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getInlineAndTitle

          public java.lang.String getInlineAndTitle()

      Title for the "And" operator (only applicable to the "inline" appearance)
      Returns:
        Current inlineAndTitle value. Default value is "and"

    - #### setInlineOrTitle

          public FilterBuilder setInlineOrTitle(java.lang.String inlineOrTitle)
                                         throws java.lang.IllegalStateException

      Title for the "Or" operator (only applicable to the "inline" appearance)
      Parameters:
        `inlineOrTitle` - New inlineOrTitle value. Default value is "or"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getInlineOrTitle

          public java.lang.String getInlineOrTitle()

      Title for the "Or" operator (only applicable to the "inline" appearance)
      Returns:
        Current inlineOrTitle value. Default value is "or"

    - #### setLastClausePrompt

          public FilterBuilder setLastClausePrompt(java.lang.String lastClausePrompt)

      The hover prompt text for the remove button in the last remaining clause, when `allowEmpty` is false.
      Parameters:
        `lastClausePrompt` - New lastClausePrompt value. Default value is "The last clause cannot be removed"
      Returns:
        `FilterBuilder` instance, for chaining setter calls

    - #### getLastClausePrompt

          public java.lang.String getLastClausePrompt()

      The hover prompt text for the remove button in the last remaining clause, when `allowEmpty` is false.
      Returns:
        Current lastClausePrompt value. Default value is "The last clause cannot be removed"

    - #### setMatchAllTitle

          public FilterBuilder setMatchAllTitle(java.lang.String matchAllTitle)
                                         throws java.lang.IllegalStateException

      Title for the "Match All" (and) operator when using `topOperatorAppearance`:"radio".
      Parameters:
        `matchAllTitle` - New matchAllTitle value. Default value is "Match All"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMatchAllTitle

          public java.lang.String getMatchAllTitle()

      Title for the "Match All" (and) operator when using `topOperatorAppearance`:"radio".
      Returns:
        Current matchAllTitle value. Default value is "Match All"

    - #### setMatchAnyTitle

          public FilterBuilder setMatchAnyTitle(java.lang.String matchAnyTitle)
                                         throws java.lang.IllegalStateException

      Title for the "Match Any" (or) operator when using `topOperatorAppearance`:"radio".
      Parameters:
        `matchAnyTitle` - New matchAnyTitle value. Default value is "Match Any"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMatchAnyTitle

          public java.lang.String getMatchAnyTitle()

      Title for the "Match Any" (or) operator when using `topOperatorAppearance`:"radio".
      Returns:
        Current matchAnyTitle value. Default value is "Match Any"

    - #### setMatchNoneTitle

          public FilterBuilder setMatchNoneTitle(java.lang.String matchNoneTitle)
                                          throws java.lang.IllegalStateException

      Title for the "Match None" (not) operator when using `topOperatorAppearance`:"radio".
      Parameters:
        `matchNoneTitle` - New matchNoneTitle value. Default value is "Match None"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMatchNoneTitle

          public java.lang.String getMatchNoneTitle()

      Title for the "Match None" (not) operator when using `topOperatorAppearance`:"radio".
      Returns:
        Current matchNoneTitle value. Default value is "Match None"

    - #### setMissingFieldPrompt

          public FilterBuilder setMissingFieldPrompt(java.lang.String missingFieldPrompt)
                                              throws java.lang.IllegalStateException

      The message to display next to fieldNames that do not exist in the available dataSource.
      Parameters:
        `missingFieldPrompt` - New missingFieldPrompt value. Default value is "[missing field definition]"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMissingFieldPrompt

          public java.lang.String getMissingFieldPrompt()

      The message to display next to fieldNames that do not exist in the available dataSource.
      Returns:
        Current missingFieldPrompt value. Default value is "[missing field definition]"

    - #### getModeSwitcher

          public Label getModeSwitcher()
                                throws java.lang.IllegalStateException

      Label to change between simple and advanced mode. When clicked the filter mode is switched to the other mode. This label is only shown if `showModeSwitcher` is true.

      Shows either `modeSwitcherSimpleMessage` or `modeSwitcherAdvancedMessage` depending on the current state of the filter.

      This component is an AutoChild named "modeSwitcher". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current modeSwitcher value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setModeSwitcherAdvancedMessage

          public FilterBuilder setModeSwitcherAdvancedMessage(java.lang.String modeSwitcherAdvancedMessage)
                                                       throws java.lang.IllegalStateException

      Title for the "Advanced.." mode switcher label (only applicable to the "radio" appearance).
      Parameters:
        `modeSwitcherAdvancedMessage` - New modeSwitcherAdvancedMessage value. Default value is "Advanced.."
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getModeSwitcherAdvancedMessage

          public java.lang.String getModeSwitcherAdvancedMessage()

      Title for the "Advanced.." mode switcher label (only applicable to the "radio" appearance).
      Returns:
        Current modeSwitcherAdvancedMessage value. Default value is "Advanced.."

    - #### setModeSwitcherFlattenWarningMessage

          public FilterBuilder setModeSwitcherFlattenWarningMessage(java.lang.String modeSwitcherFlattenWarningMessage)
                                                             throws java.lang.IllegalStateException

      Message displayed when switching to "radio" mode if the criteria will be logically changed.
      Parameters:
        `modeSwitcherFlattenWarningMessage` - New modeSwitcherFlattenWarningMessage value. Default value is "Criteria will be modified to fit in simpler editing interface"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getModeSwitcherFlattenWarningMessage

          public java.lang.String getModeSwitcherFlattenWarningMessage()

      Message displayed when switching to "radio" mode if the criteria will be logically changed.
      Returns:
        Current modeSwitcherFlattenWarningMessage value. Default value is "Criteria will be modified to fit in simpler editing interface"

    - #### setModeSwitcherSimpleMessage

          public FilterBuilder setModeSwitcherSimpleMessage(java.lang.String modeSwitcherSimpleMessage)
                                                     throws java.lang.IllegalStateException

      Title for the "Simple Mode.." mode switcher label (only applicable to the "bracket" appearance).
      Parameters:
        `modeSwitcherSimpleMessage` - New modeSwitcherSimpleMessage value. Default value is "Simple Mode.."
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getModeSwitcherSimpleMessage

          public java.lang.String getModeSwitcherSimpleMessage()

      Title for the "Simple Mode.." mode switcher label (only applicable to the "bracket" appearance).
      Returns:
        Current modeSwitcherSimpleMessage value. Default value is "Simple Mode.."

    - #### getOperatorPicker

          public SelectItem getOperatorPicker()

      Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists. See `Using AutoChildren` for details.

      AutoChild for the `FormItem` that allows a user to select the operator when creating filter clauses. Each clause will create an operatorPicker automatically. To customize this item, use `operatorPickerProperties`

      Returns:
        null

    - #### setOperatorPickerProperties

          public FilterBuilder setOperatorPickerProperties(FormItem operatorPickerProperties)
                                                    throws java.lang.IllegalStateException

      Properties to combine with the `operatorPicker` autoChild FormItem.
      Parameters:
        `operatorPickerProperties` - New operatorPickerProperties value. Default value is null
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getOperatorPickerProperties

          public FormItem getOperatorPickerProperties()

      Properties to combine with the `operatorPicker` autoChild FormItem.
      Returns:
        Current operatorPickerProperties value. Default value is null

    - #### setOperatorPickerTitle

          public FilterBuilder setOperatorPickerTitle(java.lang.String operatorPickerTitle)
                                               throws java.lang.IllegalStateException

      The title for the operator-picker select-item.
      Parameters:
        `operatorPickerTitle` - New operatorPickerTitle value. Default value is "Operator"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getOperatorPickerTitle

          public java.lang.String getOperatorPickerTitle()

      The title for the operator-picker select-item.
      Returns:
        Current operatorPickerTitle value. Default value is "Operator"

    - #### setOperatorPickerWidth

          public FilterBuilder setOperatorPickerWidth(java.lang.Integer operatorPickerWidth)
                                               throws java.lang.IllegalStateException

      Width for the operator picker formItem displayed in clauses within this FilterBuilder.
      Parameters:
        `operatorPickerWidth` - New operatorPickerWidth value. Default value is 150
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getOperatorPickerWidth

          public java.lang.Integer getOperatorPickerWidth()

      Width for the operator picker formItem displayed in clauses within this FilterBuilder.
      Returns:
        Current operatorPickerWidth value. Default value is 150

    - #### setOperatorPickerWidth

          public FilterBuilder setOperatorPickerWidth(java.lang.String operatorPickerWidth)
                                               throws java.lang.IllegalStateException

      Width for the operator picker formItem displayed in clauses within this FilterBuilder.
      Parameters:
        `operatorPickerWidth` - New operatorPickerWidth value. Default value is 150
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getOperatorPickerWidthAsString

          public java.lang.String getOperatorPickerWidthAsString()

      Width for the operator picker formItem displayed in clauses within this FilterBuilder.
      Returns:
        Current operatorPickerWidth value. Default value is 150

    - #### getRadioOperatorForm

          public DynamicForm getRadioOperatorForm()
                                           throws java.lang.IllegalStateException

      With `TopOperatorAppearance`:"radio", form that appears above the stack of clauses and allows picking the `LogicalOperator` for the overall FilterBuilder.

      By default, consists of a simple RadioGroupItem.

      This component is an AutoChild named "radioOperatorForm". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current radioOperatorForm value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getRadioOperatorLayout

          public HLayout getRadioOperatorLayout()
                                         throws java.lang.IllegalStateException

      HLayout of radioOperationForm and optional modeSwitcher.

      This component is an AutoChild named "radioOperatorLayout". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current radioOperatorLayout value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setRadioOperatorTitle

          public FilterBuilder setRadioOperatorTitle(java.lang.String radioOperatorTitle)
                                              throws java.lang.IllegalStateException

      The title for the Operator RadioGroupItem displayed in the `radioOperatorForm`.
      Parameters:
        `radioOperatorTitle` - New radioOperatorTitle value. Default value is "Overall Operator"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRadioOperatorTitle

          public java.lang.String getRadioOperatorTitle()

      The title for the Operator RadioGroupItem displayed in the `radioOperatorForm`.
      Returns:
        Current radioOperatorTitle value. Default value is "Overall Operator"

    - #### setRangeSeparator

          public FilterBuilder setRangeSeparator(java.lang.String rangeSeparator)
                                          throws java.lang.IllegalStateException

      For operators that check that a value is within a range, text to show between the start and end input fields for specifying the limits of the range.
      Parameters:
        `rangeSeparator` - New rangeSeparator value. Default value is "and"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRangeSeparator

          public java.lang.String getRangeSeparator()

      For operators that check that a value is within a range, text to show between the start and end input fields for specifying the limits of the range.
      Returns:
        Current rangeSeparator value. Default value is "and"

    - #### getRemoveButton

          public ImgButton getRemoveButton()
                                    throws java.lang.IllegalStateException

      The removal ImgButton that appears before each clause if `showRemoveButton` is set.

      This component is an AutoChild named "removeButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current removeButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setRemoveButtonPrompt

          public FilterBuilder setRemoveButtonPrompt(java.lang.String removeButtonPrompt)
                                              throws java.lang.IllegalStateException

      The hover prompt text for the remove button.
      Parameters:
        `removeButtonPrompt` - New removeButtonPrompt value. Default value is "Remove"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRemoveButtonPrompt

          public java.lang.String getRemoveButtonPrompt()

      The hover prompt text for the remove button.
      Returns:
        Current removeButtonPrompt value. Default value is "Remove"

    - #### setRetainValuesAcrossFields

          public FilterBuilder setRetainValuesAcrossFields(java.lang.Boolean retainValuesAcrossFields)

      Dictates whether values entered by a user should be retained in the value fields when a different field is selected. Default value is true.

      Note that, when switching between fields that have an optionDataSource or valueMap, this property is ignored and the values are never retained.

      Parameters:
        `retainValuesAcrossFields` - New retainValuesAcrossFields value. Default value is true
      Returns:
        `FilterBuilder` instance, for chaining setter calls

    - #### getRetainValuesAcrossFields

          public java.lang.Boolean getRetainValuesAcrossFields()

      Dictates whether values entered by a user should be retained in the value fields when a different field is selected. Default value is true.

      Note that, when switching between fields that have an optionDataSource or valueMap, this property is ignored and the values are never retained.

      Returns:
        Current retainValuesAcrossFields value. Default value is true

    - #### setSaveOnEnter

          public FilterBuilder setSaveOnEnter(java.lang.Boolean saveOnEnter)
                                       throws java.lang.IllegalStateException

      If true, when the user hits the Enter key while focused in a text-item in this FilterBuilder, we automatically invoke the user-supplied `FilterBuilder.search()` method.
      Parameters:
        `saveOnEnter` - New saveOnEnter value. Default value is null
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getSaveOnEnter

          public java.lang.Boolean getSaveOnEnter()

      If true, when the user hits the Enter key while focused in a text-item in this FilterBuilder, we automatically invoke the user-supplied `FilterBuilder.search()` method.
      Returns:
        Current saveOnEnter value. Default value is null

    - #### setShowAddButton

          public FilterBuilder setShowAddButton(java.lang.Boolean showAddButton)
                                         throws java.lang.IllegalStateException

      If set, a button will be shown underneath all current clauses allowing a new clause to be added.
      Parameters:
        `showAddButton` - New showAddButton value. Default value is true
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowAddButton

          public java.lang.Boolean getShowAddButton()

      If set, a button will be shown underneath all current clauses allowing a new clause to be added.
      Returns:
        Current showAddButton value. Default value is true

    - #### setShowFieldTitles

          public FilterBuilder setShowFieldTitles(java.lang.Boolean showFieldTitles)
                                           throws java.lang.IllegalStateException

      If true (the default), show field titles in the drop-down box used to select a field for querying. If false, show actual field names instead.
      Parameters:
        `showFieldTitles` - New showFieldTitles value. Default value is true
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowFieldTitles

          public java.lang.Boolean getShowFieldTitles()

      If true (the default), show field titles in the drop-down box used to select a field for querying. If false, show actual field names instead.
      Returns:
        Current showFieldTitles value. Default value is true

    - #### setShowHiddenFields

          public FilterBuilder setShowHiddenFields(java.lang.Boolean showHiddenFields)
                                            throws java.lang.IllegalStateException

      By default only non-hidden fields are shown for selection. To include hidden fields for selection set this property to `true`.
      Parameters:
        `showHiddenFields` - New showHiddenFields value. Default value is null
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowHiddenFields

          public java.lang.Boolean getShowHiddenFields()

      By default only non-hidden fields are shown for selection. To include hidden fields for selection set this property to `true`.
      Returns:
        Current showHiddenFields value. Default value is null

    - #### setShowLastRemoveButton

          public FilterBuilder setShowLastRemoveButton(java.lang.Boolean showLastRemoveButton)
                                                throws java.lang.IllegalStateException

      If set to false and showing clause `remove buttons` and `the last clause cannot be removed` the remove clause button will be hidden.
      Parameters:
        `showLastRemoveButton` - New showLastRemoveButton value. Default value is null
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowLastRemoveButton

          public java.lang.Boolean getShowLastRemoveButton()

      If set to false and showing clause `remove buttons` and `the last clause cannot be removed` the remove clause button will be hidden.
      Returns:
        Current showLastRemoveButton value. Default value is null

    - #### setShowModeSwitcher

          public FilterBuilder setShowModeSwitcher(java.lang.Boolean showModeSwitcher)
                                            throws java.lang.IllegalStateException

      When enabled allows FilterBuilder in `topOperatorAppearance:"radio"` or `topOperatorAppearance:"bracket"` mode to be switch to the other view by the user. "radio" mode is considered simple where "bracket" mode is advanced mode.

      Note that when switching from "bracket" to "radio" mode any entered criteria will be flattened by calling `DataSource.flattenCriteria()`. If the criteria cannot be flattened without losing symantics (see `DataSource.canFlattenCriteria()`) the user is prompted to confirm.

      If showModeSwitcher is set and topOperatorAppearance is unset:

      - when first drawn, the filterBuilder will choose which mode to use based on the provided `criteria` if any: advanced mode ("bracket") will be used if AdvancedCriteria are provided which cannot be flattened without loss of data (see `DataSource.canFlattenCriteria()`), otherwise simple mode ("radio") will be used.
      - for any calls to `setCriteria()` after draw, the FilterBuilder will switch to advanced mode if the criteria cannot be shown in simple mode without losing information, but will never automatically switch to simple mode, but an explicit call `setTopOperatorAppearance("radio")` can be used to do so.
      Parameters:
        `showModeSwitcher` - New showModeSwitcher value. Default value is null
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setModeSwitcherSimpleMessage(java.lang.String)`, `setModeSwitcherAdvancedMessage(java.lang.String)`, `setModeSwitcherFlattenWarningMessage(java.lang.String)`

    - #### getShowModeSwitcher

          public java.lang.Boolean getShowModeSwitcher()

      When enabled allows FilterBuilder in `topOperatorAppearance:"radio"` or `topOperatorAppearance:"bracket"` mode to be switch to the other view by the user. "radio" mode is considered simple where "bracket" mode is advanced mode.

      Note that when switching from "bracket" to "radio" mode any entered criteria will be flattened by calling `DataSource.flattenCriteria()`. If the criteria cannot be flattened without losing symantics (see `DataSource.canFlattenCriteria()`) the user is prompted to confirm.

      If showModeSwitcher is set and topOperatorAppearance is unset:

      - when first drawn, the filterBuilder will choose which mode to use based on the provided `criteria` if any: advanced mode ("bracket") will be used if AdvancedCriteria are provided which cannot be flattened without loss of data (see `DataSource.canFlattenCriteria()`), otherwise simple mode ("radio") will be used.
      - for any calls to `setCriteria()` after draw, the FilterBuilder will switch to advanced mode if the criteria cannot be shown in simple mode without losing information, but will never automatically switch to simple mode, but an explicit call `setTopOperatorAppearance("radio")` can be used to do so.
      Returns:
        Current showModeSwitcher value. Default value is null
      See Also:
        `getModeSwitcherSimpleMessage()`, `getModeSwitcherAdvancedMessage()`, `getModeSwitcherFlattenWarningMessage()`

    - #### setShowRemoveButton

          public FilterBuilder setShowRemoveButton(java.lang.Boolean showRemoveButton)
                                            throws java.lang.IllegalStateException

      If set, a button will be shown for each clause allowing it to be removed.
      Parameters:
        `showRemoveButton` - New showRemoveButton value. Default value is true
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowRemoveButton

          public java.lang.Boolean getShowRemoveButton()

      If set, a button will be shown for each clause allowing it to be removed.
      Returns:
        Current showRemoveButton value. Default value is true

    - #### setShowSelectionCheckbox

          public FilterBuilder setShowSelectionCheckbox(java.lang.Boolean showSelectionCheckbox)
                                                 throws java.lang.IllegalStateException

      If true, causes a CheckboxItem to appear to the left of each clause in "inline" `appearance`. This checkbox allows the user to select individual clauses so that, for example, clauses can be removed from the filterBuilder by application code. This property is ignored for appearances other than "inline".
      Parameters:
        `showSelectionCheckbox` - New showSelectionCheckbox value. Default value is false
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowSelectionCheckbox

          public java.lang.Boolean getShowSelectionCheckbox()

      If true, causes a CheckboxItem to appear to the left of each clause in "inline" `appearance`. This checkbox allows the user to select individual clauses so that, for example, clauses can be removed from the filterBuilder by application code. This property is ignored for appearances other than "inline".
      Returns:
        Current showSelectionCheckbox value. Default value is false

    - #### setShowSubClauseButton

          public FilterBuilder setShowSubClauseButton(java.lang.Boolean showSubClauseButton)
                                               throws java.lang.IllegalStateException

      Whether to show a button that allows the user to add subclauses. Defaults to false if the `TopOperatorAppearance` is "radio" or "inline", true in all other cases.
      Parameters:
        `showSubClauseButton` - New showSubClauseButton value. Default value is See Description
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowSubClauseButton

          public java.lang.Boolean getShowSubClauseButton()

      Whether to show a button that allows the user to add subclauses. Defaults to false if the `TopOperatorAppearance` is "radio" or "inline", true in all other cases.
      Returns:
        Current showSubClauseButton value. Default value is See Description

    - #### setSortFields

          public FilterBuilder setSortFields(java.lang.Boolean sortFields)
                                      throws java.lang.IllegalStateException

      Should the `FieldPicker` items be sorted alphabetically in the drop down list.
      Parameters:
        `sortFields` - New sortFields value. Default value is true
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getSortFields

          public java.lang.Boolean getSortFields()

      Should the `FieldPicker` items be sorted alphabetically in the drop down list.
      Returns:
        Current sortFields value. Default value is true

    - #### getSubClauseButton

          public IButton getSubClauseButton()
                                     throws java.lang.IllegalStateException

      Button allowing the user to add subclauses grouped by a `LogicalOperator`.

      This component is an AutoChild named "subClauseButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current subClauseButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setSubClauseButtonPrompt

          public FilterBuilder setSubClauseButtonPrompt(java.lang.String subClauseButtonPrompt)
                                                 throws java.lang.IllegalStateException

      The hover prompt text for the subClauseButton.
      Parameters:
        `subClauseButtonPrompt` - New subClauseButtonPrompt value. Default value is "Add Subclause"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getSubClauseButtonPrompt

          public java.lang.String getSubClauseButtonPrompt()

      The hover prompt text for the subClauseButton.
      Returns:
        Current subClauseButtonPrompt value. Default value is "Add Subclause"

    - #### setSubClauseButtonTitle

          public FilterBuilder setSubClauseButtonTitle(java.lang.String subClauseButtonTitle)
                                                throws java.lang.IllegalStateException

      The title of the subClauseButton
      Parameters:
        `subClauseButtonTitle` - New subClauseButtonTitle value. Default value is "+()"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getSubClauseButtonTitle

          public java.lang.String getSubClauseButtonTitle()

      The title of the subClauseButton
      Returns:
        Current subClauseButtonTitle value. Default value is "+()"

    - #### setTopOperator

          public FilterBuilder setTopOperator(LogicalOperator topOperator)

      Default logical operator for all top-level clauses in the FilterBuilder.

      May be able to be changed by the user via the UI, according to `TopOperatorAppearance`.
      If this method is called after the component has been drawn/initialized: Programmatically change the `topOperator` for this FilterBuilder.

      Parameters:
        `topOperator` - new top-level operator. Default value is "and"
      Returns:
        `FilterBuilder` instance, for chaining setter calls

    - #### getTopOperator

          public LogicalOperator getTopOperator()

      Default logical operator for all top-level clauses in the FilterBuilder.

      May be able to be changed by the user via the UI, according to `TopOperatorAppearance`.

      Returns:
        Current topOperator value. Default value is "and"

    - #### setTopOperatorAppearance

          public FilterBuilder setTopOperatorAppearance(TopOperatorAppearance topOperatorAppearance)

      How to display and edit the `top-level operator` for this FilterBuilder.

      See `TopOperatorAppearance` for a list of options.
      If this method is called after the component has been drawn/initialized: Modify `TopOperatorAppearance` at runtime.

      Note that when changing from "bracket" to "radio" mode the criteria will be flattened by calling `DataSource.flattenCriteria()` which could result in a logical change to the criteria.

      Parameters:
        `topOperatorAppearance` - new topOperatorAppearance. Default value is "bracket"
      Returns:
        `FilterBuilder` instance, for chaining setter calls

    - #### getTopOperatorAppearance

          public TopOperatorAppearance getTopOperatorAppearance()

      How to display and edit the `top-level operator` for this FilterBuilder.

      See `TopOperatorAppearance` for a list of options.

      Returns:
        Current topOperatorAppearance value. Default value is "bracket"

    - #### getTopOperatorForm

          public DynamicForm getTopOperatorForm()
                                         throws java.lang.IllegalStateException

      With `TopOperatorAppearance` "bracket" and "inline", a form that appears to the left of the stack of clauses and allows picking the `LogicalOperator` for the overall FilterBuilder (or for that specific FilterClause, in the case of "inline")

      By default, consists of a CheckboxItem if `showSelectionCheckbox` is true, and a simple SelectItem containing the available logical operators.

      If this FilterBuilder shows nested sub-clauses, the same defaults will be applied to the top-operator item for each sub-clause.

      This component is an AutoChild named "topOperatorForm". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current topOperatorForm value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getTopOperatorItem

          public SelectItem getTopOperatorItem()
                                        throws java.lang.IllegalStateException

      Automatically generated SelectItem autoChild shown in the `topOperatorForm`. Developers may customize this item using the standard autoChild pattern (by modifying `topOperatorItemDefaults` and `topOperatorItemProperties`).

      If this FilterBuilder shows nested sub-clauses, the same defaults will be applied to the top-operator item for each sub-clause.

      This component is an AutoChild named "topOperatorItem". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current topOperatorItem value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setTopOperatorItemWidth

          public FilterBuilder setTopOperatorItemWidth(int topOperatorItemWidth)
                                                throws java.lang.IllegalStateException

      Width for the `topOperatorItem` autoChild.
      Parameters:
        `topOperatorItemWidth` - New topOperatorItemWidth value. Default value is "*"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTopOperatorItemWidth

          public int getTopOperatorItemWidth()

      Width for the `topOperatorItem` autoChild.
      Returns:
        Current topOperatorItemWidth value. Default value is "*"

    - #### setTopOperatorItemWidth

          public FilterBuilder setTopOperatorItemWidth(java.lang.String topOperatorItemWidth)
                                                throws java.lang.IllegalStateException

      Width for the `topOperatorItem` autoChild.
      Parameters:
        `topOperatorItemWidth` - New topOperatorItemWidth value. Default value is "*"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTopOperatorItemWidthAsString

          public java.lang.String getTopOperatorItemWidthAsString()

      Width for the `topOperatorItem` autoChild.
      Returns:
        Current topOperatorItemWidth value. Default value is "*"

    - #### setTopOperatorOptions

          public FilterBuilder setTopOperatorOptions(OperatorId... topOperatorOptions)
                                              throws java.lang.IllegalStateException

      Logical operators to allow for `TopOperatorAppearance`s of "radio" and "bracket".

      Note that this list may be further limited according to the `available operators` returned by the `DataSource`.

      Parameters:
        `topOperatorOptions` - New topOperatorOptions value. Default value is ["and", "or", "not"]
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTopOperatorOptions

          public OperatorId[] getTopOperatorOptions()

      Logical operators to allow for `TopOperatorAppearance`s of "radio" and "bracket".

      Note that this list may be further limited according to the `available operators` returned by the `DataSource`.

      Returns:
        Current topOperatorOptions value. Default value is ["and", "or", "not"]

    - #### setTopOperatorTitle

          public FilterBuilder setTopOperatorTitle(java.lang.String topOperatorTitle)
                                            throws java.lang.IllegalStateException

      The title for the left-aligned Operator selectItem in the `topOperatorForm`.
      Parameters:
        `topOperatorTitle` - New topOperatorTitle value. Default value is "Clause Operator"
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTopOperatorTitle

          public java.lang.String getTopOperatorTitle()

      The title for the left-aligned Operator selectItem in the `topOperatorForm`.
      Returns:
        Current topOperatorTitle value. Default value is "Clause Operator"

    - #### setValidateOnChange

          public FilterBuilder setValidateOnChange(java.lang.Boolean validateOnChange)
                                            throws java.lang.IllegalStateException

      If true (the default), validates each entered value when it changes, to make sure it is a a valid value of its type (valid string, number, and so on). No other validation is carried out. If you switch this property off, it is still possible to validate the `FilterBuilder` by calling `validate()` from your own code.
      Parameters:
        `validateOnChange` - New validateOnChange value. Default value is true
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValidateOnChange

          public java.lang.Boolean getValidateOnChange()

      If true (the default), validates each entered value when it changes, to make sure it is a a valid value of its type (valid string, number, and so on). No other validation is carried out. If you switch this property off, it is still possible to validate the `FilterBuilder` by calling `validate()` from your own code.
      Returns:
        Current validateOnChange value. Default value is true

    - #### setValueItemWidth

          public FilterBuilder setValueItemWidth(java.lang.Integer valueItemWidth)
                                          throws java.lang.IllegalStateException

      Width for the value-chooser formItem displayed in clauses within this FilterBuilder. Note that depending on the selected operator type, this item may not be displayed, or may have different characteristics. See `getValueFieldProperties()` for information on customizing the value item.
      Parameters:
        `valueItemWidth` - New valueItemWidth value. Default value is 150
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueItemWidth

          public java.lang.Integer getValueItemWidth()

      Width for the value-chooser formItem displayed in clauses within this FilterBuilder. Note that depending on the selected operator type, this item may not be displayed, or may have different characteristics. See `getValueFieldProperties()` for information on customizing the value item.
      Returns:
        Current valueItemWidth value. Default value is 150

    - #### setValueItemWidth

          public FilterBuilder setValueItemWidth(java.lang.String valueItemWidth)
                                          throws java.lang.IllegalStateException

      Width for the value-chooser formItem displayed in clauses within this FilterBuilder. Note that depending on the selected operator type, this item may not be displayed, or may have different characteristics. See `getValueFieldProperties()` for information on customizing the value item.
      Parameters:
        `valueItemWidth` - New valueItemWidth value. Default value is 150
      Returns:
        `FilterBuilder` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueItemWidthAsString

          public java.lang.String getValueItemWidthAsString()

      Width for the value-chooser formItem displayed in clauses within this FilterBuilder. Note that depending on the selected operator type, this item may not be displayed, or may have different characteristics. See `getValueFieldProperties()` for information on customizing the value item.
      Returns:
        Current valueItemWidth value. Default value is 150

    - #### addClause

          public void addClause(FilterClause filterClause)

      Add a new `FilterClause` to this FilterBuilder.

      This API is intended for the rare use case of adding a highly customized FilterClause component that does not include the standard field/operator/value picking interface, instead providing a custom interface and returning a criterion via `FilterClause.getCriterion()`.

      If you just want to programmatically add a new FilterClause showing a specific Criterion use `addCriterion()`.

      If you want to use the standard field/operator/value interface but provide a custom control for editing the value, see `DataSource.addSearchOperator()` and `Operator.editorType`.

      Parameters:
        `filterClause` - A `FilterClause` instance

    - #### addCriterion

          public void addCriterion(Criterion criterion)

      Add a new criterion, including recursively adding sub-criteria for a criterion that contains other criteria.
      Parameters:
        `criterion` - new criterion to be added

    - #### clearCriteria

          public void clearCriteria()

      Clear all current criteria.

    - #### addFilterChangedHandler

          public com.google.gwt.event.shared.HandlerRegistration addFilterChangedHandler(FilterChangedHandler handler)

      Add a filterChanged handler.

      Handler fired when there is a change() event fired on any FormItem within the filterBuilder.

      Specified by:
        `addFilterChangedHandler` in interface `HasFilterChangedHandlers`
      Parameters:
        `handler` - the filterChanged handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### getEditorType

          public java.lang.String getEditorType(DataSourceField field,
                                                OperatorId operatorId)

      Returns the type of editor to use for the field.

      Default behavior is to use the `Operator.editorType` for a custom operator, otherwise, use `RelativeDateItem` for before/after/between operators on date fields, otherwise, use the same editor as would be chosen by a `SearchForm`.

      Parameters:
        `field` - DataSourceField definition
        `operatorId` - `OperatorId` for the chosen operator
      Returns:
        Smart GWT class to use (must be subclass of FormItem). See `SCClassName`

    - #### getSelectedClauses

          public FilterClause[] getSelectedClauses()

      Returns the list of this FilterBuilder's FilterClauses that are currently selected. A clause is "selected" if the user has checked the checkbox next to it; therefore, this method always returns an empty list unless the `showSelectionCheckbox` property is set. This method is only applicable where `TopOperatorAppearance` is "inline" (because that is the only appearance that supports `showSelectionCheckbox`)
      Returns:
        The list of selected clauses

    - #### addSearchHandler

          public com.google.gwt.event.shared.HandlerRegistration addSearchHandler(SearchHandler handler)

      Add a search handler.

      A StringMethod that is automatically invoked if `FilterBuilder.saveOnEnter` is set and the user presses Enter whilst in a text-item in any clause or subclause.

      Specified by:
        `addSearchHandler` in interface `HasSearchHandlers`
      Parameters:
        `handler` - the search handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### validate

          public java.lang.Boolean validate()

      Validate the clauses of this FilterBuilder.
      Returns:
        true if all clauses are valid, false otherwise

    - #### setDefaultProperties

          public static void setDefaultProperties(FilterBuilder filterBuilderProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `filterBuilderProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### onInit

          public void onInit()

      Overrides:
        `onInit` in class `Layout`

    - #### onInit_FilterBuilder

          protected void onInit_FilterBuilder()

    - #### setShowFieldTitles

          public void setShowFieldTitles(boolean showFieldTitles)
                                  throws java.lang.IllegalStateException

      If true (the default), show field titles in the drop-down box used to select a field for querying. If false, show actual field names instead.
      Parameters:
        `showFieldTitles` - showFieldTitles default is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setDataSource

          public void setDataSource(DataSource dataSource)

      DataSource this filter should use for field definitions and available `Operator`s.
      Parameters:
        `dataSource` - dataSource Default value is null

    - #### getCriteria

          public AdvancedCriteria getCriteria(boolean includeEmptyValues)

      Initial criteria.

      When initialized with criteria, appropriate clauses for editing the provided criteria will be automatically generated.

      Note that empty or partial criteria are allowed, for example, criteria that specify `Criterion.fieldName` only will generate an expression with the operator not chosen yet, and a `Criterion` with a logical operator ("and" or "or") but not `subcriteria` defined will generate an empty subclause.

      Parameters:
        `By` - default if a user has selected a field and operator type, but has failed to enter a value for the field it will be skipped. This optional parameter allows you to retrieve all criteria, including those with an empty value attribute.
      Returns:
        Get the criteria entered by the user. Default value is null

    - #### removeClause

          public void removeClause(FilterClause clause)

      Remove a clause this FilterBuilder is currently showing.
      Parameters:
        `clause` - clause as retrieved from filterBuilder.clauses

    - #### getMembers

          public Canvas[] getMembers()

      Description copied from class: `Layout`
      An array of canvases that will be contained within this layout. You can set the following properties on these canvases (in addition to the standard component properties):
      - `layoutAlign` -- specifies the member's alignment along the breadth axis; valid values are "top", "center" and "bottom" for a horizontal layout and "left", "center" and "right" for a vertical layout (see `defaultLayoutAlign` for default implementation.)
      - `showResizeBar` -- set to true to show a resize bar (default is false)
      Height and width settings found on members are interpreted by the Layout according to the `layout policy`.

      Note that it is valid to have null slots in the provided `members` Array, and the Layout will ignore those slots. This can be useful to keep code compact, for example, when constructing the `members` Array, you might use an expression that either returns a component or null depending on whether the component should be present. If the expression returns null, the null slot will be ignored by the Layout.

      Overrides:
        `getMembers` in class `Layout`
      Returns:
        Get the Array of members. Default value is null

    - #### getValueFieldProperties

          public FormItem getValueFieldProperties(FieldType type,
                                                  java.lang.String fieldName,
                                                  OperatorId operatorId,
                                                  ValueItemType itemType,
                                                  java.lang.String fieldType)

      Override to return properties for the FormItem(s) used for the "value" field displayed within clauses within this filterBuilder.

      Note that the valueType impacts when this method is called. For operators with valueType `"fieldType"` or `"custom"`, a single value field is displayed. For operators with valueType `"valueRange"` two value-field items are displayed (one for the start and one for the end position). The `valueItemType` parameter may be used to determine which form item is being generated.

      Note : This is an override point

      Parameters:
        `type` - type of the DataSource field for this filter row. Note that for `DataSourceSimpleTypeField` SimpleType based DataSource fields this attribute will be null
        `fieldName` - name of the DataSource field for this filter row
        `operatorId` - `OperatorId` for the chosen operator
        `itemType` - What valueItem is being generated.
        `fieldType` - type of the DataSource field for this filter row. Typically one would use the parameter but this value is useful when the `FieldType` is a custom SimpleType in which case the type will be `FieldType.CUSTOM` and this parameter is the name of the SimpleType
      Returns:
        properties for the value field

    - #### setFieldOperatorCustomizer

          public void setFieldOperatorCustomizer(FieldOperatorCustomizer customizer)

      This method installs a customizer that returns the set of OperatorIds applicable to the passed fieldName
      Parameters:
        `customizer` - the customizer to execute.

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.form.FilterBuilderLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `Layout`